DECLARE FUNCTION Getword% ()
DECLARE FUNCTION Getdword& ()
'$INCLUDE: 'menulib.bi'
'$DYNAMIC
DECLARE SUB Playfli (Name$)
'COMMON SHARED a$, Vl%, Curseg%
DIM SHARED a AS STRING
DIM SHARED Vl AS INTEGER
DIM SHARED Curseg AS INTEGER
'Check out the REMs in the PLAYFLI sub
'This is a .FLI player written in Quick Basic, it's relatively fast
'I used an awesome routine I found on a BBS to do VGA paging.
'I think it was Matt Pritchard.... thanks man!
'If that dude finds this code, he can go ahead and steal this
'Player. Thanks....
'Hey, this is the NEW version, it can handle frames larger than 8K!
'Hey, this is a NEWER version, it runs faster and when the palette changes
'during the fli, it no longer messes up!
DEFINT A-Z
CLS
TYPE Fheader  'This is the format of the Header on a .FLI
	Size AS LONG
	Typ AS STRING * 2
	Numf AS INTEGER
	Wid AS INTEGER
	Hei AS INTEGER
	Bits AS INTEGER
	Flag AS INTEGER
	Speed AS INTEGER
	Nex AS LONG
	Fri AS LONG
	Blank AS STRING * 102
END TYPE
TYPE Frameh 'This is the header attached to each frame on a .FLI
	Size AS LONG
	Typf AS INTEGER
	Nchu AS INTEGER
	Blank AS STRING * 8
END TYPE
TYPE Chunkh 'This is the header for each Chunk in a frame
	Size AS LONG
	Typec AS INTEGER
END TYPE
IF COMMAND$ = "" THEN 'Access input
	PRINT "File not specified!"
	END
END IF
'DIM SHARED Lns AS LONG 'This is for QB enviroment (SLOW)
'Un rem the next line when compling! (FAST!)
DIM SHARED Lns AS INTEGER
DIM SHARED Buffer(1 TO 32767) AS INTEGER
Nme$ = COMMAND$
IF INSTR(Nme$, ".") = 0 THEN Nme$ = Nme$ + ".FLI"
PRINT "Dean's FLI player! (640x400x256)(VESA!!)"
PRINT "This was written in QUICK BASIC!!!"
PRINT "Now playing: "; Nme$
PRINT "Press any key to continue..."
DO WHILE INKEY$ = "": LOOP
SCREEN 13
Setvesa (Vesa640x480)'Go into the mode with paging


OPEN Nme$ FOR BINARY AS #1
DO UNTIL a$ <> ""
	a$ = INKEY$
	Playfli Nme$ 'Play the .FLI
LOOP
CLOSE #1
SCREEN 0
WIDTH 80
END

REM $STATIC
FUNCTION Getdword&
Tempval& = 0
r = PEEK(Lns + Vl - 1)
Lns = Lns + 1
b = PEEK(Lns + Vl - 1)
Lns = Lns + 1
c = PEEK(Lns + Vl - 1)
Lns = Lns + 1
d = PEEK(Lns + Vl - 1)
Lns = Lns + 1
DEF SEG = VARSEG(Tempval&)
v = VARPTR(Tempval&)
POKE (v), r
POKE (v + 1), b
POKE (v + 2), c
POKE (v + 3), d
DEF SEG = Curseg
Getdword& = Tempval&

END FUNCTION

FUNCTION Getword%
Tempval = 0
r = PEEK(Lns + Vl - 1)
Lns = Lns + 1
b = PEEK(Lns + Vl - 1)
Lns = Lns + 1
DEF SEG = VARSEG(Tempval)
v = VARPTR(Tempval)
POKE (v), r
POKE (v + 1), b
DEF SEG = Curseg
Getword% = Tempval

END FUNCTION

SUB Playfli (Name$)
DIM Byte AS STRING * 1 'Varibles for compatibility
DIM Word AS INTEGER
DIM Dword AS LONG
DIM Qword AS DOUBLE
DIM Fhead AS Fheader
DIM Chunk AS Chunkh

SEEK #1, 1
GET #1, , Fhead 'Get the header data
DIM Frame AS Frameh 'Set the Frame varible
Lr = LOC(1)
GET #1, , Frame
Seekn& = Frame.Size + Lr + 1
Inregs.ax = &H3F00
Inregs.bx = FILEATTR(1, 2)
Inregs.cx = VAL("&H" + HEX$(Frame.Size))
Inregs.ds = VARSEG(Buffer(1))
Inregs.dx = VARPTR(Buffer(1))

CALL interruptx(&H21, Inregs, Outregs)

'Fm$ = SPACE$(Frame.Size)
'GET #1, , Fm$ 'Get the whole FIRST frame into memory
DEF SEG = VARSEG(Buffer(1))
Curseg = VARSEG(Buffer(1))
Vl = VARPTR(Buffer(1))


Bwv = 0
Lns = 1
Apage = 1
Vpage = 0

FOR Frms = 1 TO Fhead.Numf
	IF INKEY$ <> "" THEN
		a$ = " "
		EXIT SUB
	END IF
	'SET.ACTIVE.PAGE Apage 'Do some page swapping
	'SET.DISPLAY.PAGE Vpage
	IF Frms > 1 THEN
		'COPY.BITMAP Vpage, 80, 100, 239, 299, Apage, 80, 100'Make sure the page your using is up to date
		'DRAW.LINE 79, 99, 240, 99, Bwhite
		'DRAW.LINE 240, 99, 240, 300, Bwhite
		'DRAW.LINE 240, 300, 79, 300, Bwhite
		'DRAW.LINE 79, 300, 79, 99, Bwhite
		
		SEEK #1, Seekn&
		GET #1, , Frame 'Get the frame data
		Seekn& = Seekn& + Frame.Size 'Store where next frame in file is
		Inregs.ax = &H3F00
		Inregs.bx = FILEATTR(1, 2)
		Inregs.cx = VAL("&H" + HEX$(Frame.Size))
		Inregs.ds = VARSEG(Buffer(1))
		Inregs.dx = VARPTR(Buffer(1))

		CALL interruptx(&H21, Inregs, Outregs)

		'Fm$ = SPACE$(Frame.Size)
		'GET #1, , Fm$ 'Get the whole FIRST frame into memory
		DEF SEG = VARSEG(Buffer(1))
		Curseg = VARSEG(Buffer(1))
		Vl = VARPTR(Buffer(1))
	    
		Lns = 1
	END IF
	 
	FOR t = 1 TO Frame.Nchu
		  
		Chunk.Size = Getdword 'Get chunk data
		Chunk.Typec = Getword
		c = Chunk.Typec
		IF c = 11 THEN 'This is if its a PALETTE block
			Word = Getword
			Cl = 0
			FOR i = 1 TO Word
				r = PEEK(Vl + Lns - 1)
				Lns = Lns + 1
				Cl = Cl + r
				f = PEEK(Vl + Lns - 1)
				Lns = Lns + 1
				IF f = 0 THEN f = 256
				FOR e = Cl TO f - 1
					OUT &H3C8, e
					'I know Matt's routines
					'had a palette setting command,
					'but this is still faster
					r = PEEK(Vl + Lns - 1)
					Lns = Lns + 1
					OUT &H3C9, r
					g = PEEK(Vl + Lns - 1)
					Lns = Lns + 1
					OUT &H3C9, g
					b = PEEK(Vl + Lns - 1)
					Lns = Lns + 1
					OUT &H3C9, b
					IF (r \ 4 = g \ 4) AND (g \ 4 = b \ 4) AND (r > Bwv) THEN
						Bwhite = e
						Bwv = r
					END IF
				NEXT e
				DEF SEG = &HA000
				FOR Ytx = 159 TO 480
					Writedot Ytx, 99, Bwhite
					Writedot Ytx, 300, Bwhite
				NEXT Ytx
				FOR Ytx = 99 TO 300
					Writedot 159, Ytx, Bwhite
					Writedot 480, Ytx, Bwhite
				NEXT Ytx
				    
		    
			NEXT i
		END IF
		IF c = 15 THEN 'This is if it's a FIRST frame RLE
			x = 0
			y = 0
			DO
				Nump = PEEK(Vl + Lns - 1) 'Forget the stupid MID$ command
							  'PEEK is faster!
				Lns = Lns + 1
				FOR r = 1 TO Nump
					u = PEEK(Vl + Lns - 1)
					Lns = Lns + 1
					IF u < 128 THEN
						Cr = PEEK(Vl + Lns - 1)
						Lns = Lns + 1
						DEF SEG = &HA000
						FOR Rt = 0 TO u - 1
							Writedot 160 + x + Rt, 100 + y, Cr
						NEXT Rt
						DEF SEG = Curseg
						'DRAW.LINE 80 + x , 100 + y, 80 + (x + u - 1, y + 100, Cr
						x = x + u

					END IF
					IF u > 127 THEN
						u = ABS(u - 255) + 1
						FOR w = 1 TO u
							f = PEEK(Vl + Lns - 1)
							Lns = Lns + 1
							DEF SEG = &HA000
							Writedot 160 + x, y + 100, f
							DEF SEG = Curseg
							x = x + 1
						NEXT w
					END IF
				NEXT r
				x = 0
				y = y + 1
			LOOP UNTIL y >= 199
		END IF
		IF c = 12 THEN 'This is if it's another frame, it skips lines but
					'it's also an RLE
			y = Getword
			x = 0
			Clins = Getword
			FOR Ncl = 1 TO Clins
				r = PEEK(Vl + Lns - 1) 'Get num of lines to skip
				Lns = Lns + 1
				IF r = 0 THEN GOTO Skip
				FOR Npa = 1 TO r
Repeat:
					Pskip = PEEK(Vl + Lns - 1) 'Get num of pixels to skip
					Lns = Lns + 1
					x = x + Pskip
					IF Pkskip = 255 THEN GOTO Repeat
					Snd = PEEK(Vl + Lns - 1)
					Lns = Lns + 1
				    
					IF Snd < 128 THEN
						FOR Rd = 1 TO Snd
							Clr = PEEK(Vl + Lns - 1)
							Lns = Lns + 1
							DEF SEG = &HA000
							Writedot 160 + x, y + 100, Clr
							DEF SEG = Curseg
							x = x + 1
						NEXT Rd
					ELSE
						Snd = ABS(Snd - 256)
						Clr = PEEK(Vl + Lns - 1)
						Lns = Lns + 1
						DEF SEG = &HA000
						FOR Rt = 0 TO Snd - 1
							Writedot 160 + x + Rt, 100 + y, Clr
						NEXT Rt
						DEF SEG = Curseg
						'DRAW.LINE 80 + x \ 2, 100 + y, 80 + (x + Snd - 1) \ 2, 100 + y, Clr
						x = x + Snd
					END IF
				NEXT Npa
Skip:
			x = 0
			y = y + 1
			NEXT Ncl
		END IF
		'IF c = 13 THEN
		'     CLEAR.VGA.SCREEN 0
		'END IF
		'IF c = 16 THEN
		'     DRAW.BITMAP Buffer(4), 0, 0, 320, 200
		'END IF
    
	NEXT t
	SWAP Apage, Vpage 'exchange pages
'     FOR Wt = 1 TO Fhead.Speed
'          Sync.Display 'Do delay for num set of video cycles
'     NEXT Wt 'If not needed, it goes faster on fast frame rate FLIs if REMED
NEXT Frms
END SUB

